Imports Stimulsoft.Base
Imports Stimulsoft.Base.Drawing
Imports Stimulsoft.Controls
Imports Stimulsoft.Report
Imports Stimulsoft.Report.Components

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents Button1 As System.Windows.Forms.Button
    Friend WithEvents DataGrid1 As System.Windows.Forms.DataGrid
    Friend WithEvents Table As System.Data.DataTable
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(Form1))
        Me.Button1 = New System.Windows.Forms.Button()
        Me.DataGrid1 = New System.Windows.Forms.DataGrid()
        Me.Table = New System.Data.DataTable()
        CType(Me.DataGrid1, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.Table, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'Button1
        '
        Me.Button1.Location = New System.Drawing.Point(216, 248)
        Me.Button1.Name = "Button1"
        Me.Button1.TabIndex = 0
        Me.Button1.Text = "Show"
        '
        'DataGrid1
        '
        Me.DataGrid1.DataMember = ""
        Me.DataGrid1.HeaderForeColor = System.Drawing.SystemColors.ControlText
        Me.DataGrid1.Location = New System.Drawing.Point(8, 8)
        Me.DataGrid1.Name = "DataGrid1"
        Me.DataGrid1.Size = New System.Drawing.Size(280, 232)
        Me.DataGrid1.TabIndex = 1
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(292, 273)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.DataGrid1, Me.Button1})
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.Name = "Form1"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "Print Table"
        CType(Me.DataGrid1, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.Table, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Table.Columns.Add()
        Table.Columns.Add()
        Dim Row1 As DataRow = Table.NewRow
        Dim Row2 As DataRow = Table.NewRow
        Dim Row3 As DataRow = Table.NewRow
        Row1.ItemArray = New String() {"1", "One"}
        Row2.ItemArray = New String() {"2", "Two"}
        Row3.ItemArray = New String() {"3", "Three"}
        Table.Rows.Add(Row1)
        Table.Rows.Add(Row2)
        Table.Rows.Add(Row3)
        DataGrid1.DataSource = Table
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        PrintTable(Table)
    End Sub

    Private Sub PrintTable(ByVal Data As DataTable)

        Dim Report As New StiReport()
        Report.ScriptLanguage = StiReportLanguageType.VB

        'Add data to datastore
        Report.RegData("data", Data)
        'Fill dictionary
        Report.Dictionary.Synchronize()
        Report.Dictionary.DataSources.Item(0).Name = "data"
        Report.Dictionary.DataSources.Item(0).Alias = "data"

        Dim Page As StiPage = Report.Pages.Item(0)

        'Create HeaderBand
        Dim HeaderBand As New StiHeaderBand()
        HeaderBand.Height = 0.5
        HeaderBand.Name = "HeaderBand"
        Page.Components.Add(HeaderBand)

        'Create Databand
        Dim Databand As New StiDataBand()
        Databand.DataSourceName = "data"
        Databand.Height = 0.5
        Databand.Name = "DataBand"
        Page.Components.Add(Databand)

        'Create texts
        Dim Pos As Double = 0
        Dim ColumnWidth As Double = StiAlignValue.AlignToMinGrid(Page.Width / Data.Columns.Count, 0.1, True)
        Dim NameIndex As Integer = 1
        Dim Column As DataColumn
        For Each Column In data.Columns

            'Create text on header
            Dim HeaderText As New StiText(New RectangleD(Pos, 0, ColumnWidth, 0.5))
            HeaderText.Text.Value = Column.Caption
            HeaderText.HorAlignment = StiTextHorAlignment.Center
            HeaderText.Name = "HeaderText" + NameIndex.ToString()
            HeaderText.Brush = New StiSolidBrush(Color.LightGreen)
            HeaderText.Border.Side = StiBorderSides.All
            HeaderBand.Components.Add(HeaderText)

            'Create text on Data Band
            Dim DataText As New StiText(New RectangleD(Pos, 0, ColumnWidth, 0.5))
            DataText.Text.Value = "{data." + Column.ColumnName + "}"
            DataText.Name = "DataText" + NameIndex.ToString()
            DataText.Border.Side = StiBorderSides.All

            'Add highlight
            Dim Condition As StiCondition = New StiCondition()
            Condition.BackColor = Color.CornflowerBlue
            Condition.TextColor = Color.Black
            Condition.Expression.Value = "(Line And 1) = 1"
            Condition.Item = StiFilterItem.Expression
            DataText.Conditions.Add(Condition)

            Databand.Components.Add(DataText)

            Pos = Pos + ColumnWidth

            NameIndex = NameIndex + 1

        Next


        'Create FooterBand
        Dim FooterBand As New StiFooterBand()
        FooterBand.Height = 0.5
        FooterBand.Name = "FooterBand"
        Page.Components.Add(FooterBand)

        'Create text on footer
        Dim FooterText As New StiText(New RectangleD(0, 0, Page.Width, 0.5))
        FooterText.Text.Value = "Count - {Count()}"
        FooterText.HorAlignment = StiTextHorAlignment.Right
        FooterText.Name = "FooterText"
        FooterText.Brush = New StiSolidBrush(Color.LightGreen)
        FooterBand.Components.Add(FooterText)

        'Render without progress bar
        Report.Render(False)
        Report.Show()
    End Sub

End Class
